import { type IType, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class IcrClassrelationtemplatedetail {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  ClassRelationTemplateId!: IType<number, bigint>;
  SchoolId!: IType<number, bigint>;
  GradeId!: IType<number, bigint>;
  ClassId!: IType<number, bigint>;
  CloudClassId!: IType<number, bigint>;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const IcrClassrelationtemplatedetailSchema = defineEntity({
  class: IcrClassrelationtemplatedetail,
  comment: '班级关联关系绑定',
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    ClassRelationTemplateId: p.bigint().name('ClassRelationTemplateId').columnType('bigint').comment('模板id'),
    SchoolId: p.bigint().name('SchoolId').columnType('bigint').comment('学校Id'),
    GradeId: p.bigint().name('GradeId').columnType('bigint').comment('年级Id'),
    ClassId: p.bigint().name('ClassId').columnType('bigint').comment('班级Id'),
    CloudClassId: p.bigint().name('CloudClassId').columnType('bigint').comment('云班ID'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
